<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFuncionariosERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFuncionariosERP
 * @subpackage Arrays
 */
class ArrayOfFuncionariosERP extends AbstractStructArrayBase
{
    /**
     * The FuncionariosERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FuncionariosERP[]
     */
    public $FuncionariosERP;
    /**
     * Constructor method for ArrayOfFuncionariosERP
     * @uses ArrayOfFuncionariosERP::setFuncionariosERP()
     * @param \StructType\FuncionariosERP[] $funcionariosERP
     */
    public function __construct(array $funcionariosERP = array())
    {
        $this
            ->setFuncionariosERP($funcionariosERP);
    }
    /**
     * Get FuncionariosERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FuncionariosERP[]|null
     */
    public function getFuncionariosERP()
    {
        return isset($this->FuncionariosERP) ? $this->FuncionariosERP : null;
    }
    /**
     * Set FuncionariosERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FuncionariosERP[] $funcionariosERP
     * @return \ArrayType\ArrayOfFuncionariosERP
     */
    public function setFuncionariosERP(array $funcionariosERP = array())
    {
        foreach ($funcionariosERP as $arrayOfFuncionariosERPFuncionariosERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfFuncionariosERPFuncionariosERPItem instanceof \StructType\FuncionariosERP) {
                throw new \InvalidArgumentException(sprintf('The FuncionariosERP property can only contain items of \StructType\FuncionariosERP, "%s" given', is_object($arrayOfFuncionariosERPFuncionariosERPItem) ? get_class($arrayOfFuncionariosERPFuncionariosERPItem) : gettype($arrayOfFuncionariosERPFuncionariosERPItem)), __LINE__);
            }
        }
        if (is_null($funcionariosERP) || (is_array($funcionariosERP) && empty($funcionariosERP))) {
            unset($this->FuncionariosERP);
        } else {
            $this->FuncionariosERP = $funcionariosERP;
        }
        return $this;
    }
    /**
     * Add item to FuncionariosERP value
     * @throws \InvalidArgumentException
     * @param \StructType\FuncionariosERP $item
     * @return \ArrayType\ArrayOfFuncionariosERP
     */
    public function addToFuncionariosERP(\StructType\FuncionariosERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FuncionariosERP) {
            throw new \InvalidArgumentException(sprintf('The FuncionariosERP property can only contain items of \StructType\FuncionariosERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->FuncionariosERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FuncionariosERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FuncionariosERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FuncionariosERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FuncionariosERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FuncionariosERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FuncionariosERP
     */
    public function getAttributeName()
    {
        return 'FuncionariosERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfFuncionariosERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
